<?php
include "../../common/common_define.php";

$gmt_time = array(		"MHT+12",
						"SST+11",
						"HST+10",
						"AKST+9",
						"PST+8",
						"MST+7",
						"MST+7",
						"CST+6",
						"CDT+6",
						"CST+6", 
						"COT+5",
						"EST+5",
						"EST+5",
						"AST+4",
						"VET+4",
						"CLT+4",
						"NST+0330",
						"ESAST+3",
						"ART+3",
						"MAST+2",
						"AZOST+1",
						"GMT0",
						"CEST-1",
						"CEST-1",
						"CEST-1",
						"CEST-1",
						"EEST-2",
						"EEST-2",
						"EEST-2",
						"EEST-2",
						"EEST-2",
						"IST-2",
						"ADT-3",
						"MSD-3",
						"EAT-3",
						"IRST-0330",
						"GST-4",
						"GEST-4",
						"AFT-0430",
						"PKT-5",
						"PKT-5",
						"IST-0530",
						"ALMST-6",
						"LKT-6",
						"ICT-7",
						"HKT-8",
						"WST-8",
						"SGT-8",
						"CST-8",
						"JST-9",
						"KST-9",
						"YAKST-9",
						"CST-0930",
						"CST-0930",
						"EST-10",
						"EST-10",
						"PGT-10",
						"EST-10",
						"VLAST-10",
						"MAGST-11",
						"NZST-12"); 

$zone_name = array(		"Eniwetok Kwajalein",
 						"MidwayIsland ,Samoa",
 						"Hawaii",
						"Alaska",
						"Pacific Time(US & Canada); Tijuana",
						"Arizona",
						"Mountain Time(US & Canada)",
						"Central Time(US & Canada)",
						"Mexico City, Tegucigalpa",
						"Saskatchewan",
						"Bogota, Lima, Quito",
						"Eastern Time(US &amp; Canada)",
						"Indiana(East)",
						"Atlantic Time(Canada)",
						"Caracas, La Paz",
						"Santiago",
						"Newfoundland",
						"Brasilia",
						"Buenos Aires, Georgetown",
						"Mid-Atlantic",
						"Azores, Cape Verde Is.",
						"Greenwich Mean Time : Dublin, Lisbon, London",
						"Amsterdam, Berlin, Rome, Stockholm, Vienna",
						"Belgrade, Bratislava, Budapest, Ljubljana",
						"Brussels, Copenhagen, Madrid, Paris, Vilnius",
						"Sarajevo, Skopje, Sofija, Warsaw, Zagreb",
						"Athens, Istanbul, Minsk",
						"Bucharest",
  						"Cairo",
						"Harare, Pretoria",
						"Helsinki, Riga, Tallinn",
						"Israel",
						"Baghdad, Kuwait, Riyadh",
						"Moscow, St. Petersburg, Volgograd",
						"Nairobi",
						"Tehran",
						"Abu Dhabi, Muscat",
						"Baku, Tbilisi",
						"Kabul",
						"Eekaterinburg",
						"Islamabad, Karachi, Tashkent",
						"Bombay, Calcutta, Madras, New Delhi",
						"Almaty, Dhaka",
						"Colombo",
						"Bangkok, Hanoi, Jakarta",
						"Beijing, Chongqing, Hong Kong, Urumqi",
						"Perth",
						"Singapore",
						"Taipei",
  						"Osaka, Sapporo, Tokyo",
						"Seoul",
						"Yakutsk",
						"Adelaide",
						"Darwin",
						"Brisbane",
						"Canberra, Melbourne, Sydney",
						"Guam, Port Moresby",
						"Hobart",
						"Vladivostok",		
  						"Magadan, Solomon Is., New Caledonia",
						"Auckland, Wellington");			

$loadxml = simplexml_load_file(TIME_CONF_XML);

$time_servert_name 	= common_xmlReader($loadxml, XML_TIME_SER_IP_PATH);
$time_zone_idx 		= common_xmlReader($loadxml, XML_TIME_ZONE_INDEX);
$time_setup 		= common_xmlReader($loadxml, XML_TIME_SER_MODE_PATH);

// time zone change
$changeTime		= false;
$changeTimeZone	= false;
	
$idx = (int) $time_zone_idx;

$manual_year 	= date('Y');
$manual_month	= date('m');
$manual_day		= date('d');
$manual_hour 	= date('H');
$manual_minute 	= date('i');
$manual_second 	= date('s');		

function isChangedTime() {
	if ($manual_year	!= $_POST['setYear'])	return true;
	if ($manual_month 	!= $_POST['setMonth'])	return true;
	if ($manual_day		!= $_POST['setDay'])	return true;
	if ($manual_hour	!= $_POST['setHour'])	return true;
	if ($manual_minute	!= $_POST['setMinute'])	return true;
	if ($manual_second	!= $_POST['setSecond'])	return true;
			
	return false;
}
	
if( $time_zone_idx != $_POST['timezone'] ) {
	$logmsg = TIME_DATE." - [".TIME_ZONE."] ".$zone_name[$idx]." -> ".$zone_name[$_POST['timezone']];
	common_logWrite($logmsg);
	
	common_xmlWriter(TIME_CONF_XML, XML_TIME_ZONE_PATH, $gmt_time[$_POST['timezone']] );	// gmt name
	common_xmlWriter(TIME_CONF_XML, XML_TIME_ZONE_INDEX, (int)$_POST['timezone']);				// gmt index
	
	$changeTime		= true;
	$changeTimeZone = true;
}
	
// time setup change
if( isset($_POST['setAuto']) ) {
	if( $time_setup == TYPE_MANUAL ) {
		common_xmlWriter(TIME_CONF_XML, XML_TIME_SER_MODE_PATH,TYPE_SERVER);
		$logmsg = TIME_DATE." - [".TIME_SETUP."] ".TYPE_MANUAL." -> ".TYPE_SERVER;
		common_logWrite($logmsg);
	}
}

if( isset($_POST['setManual']) ) {
	if( $time_setup == TYPE_SERVER ) {
		common_xmlWriter(TIME_CONF_XML, XML_TIME_SER_MODE_PATH,TYPE_MANUAL);
		$logmsg = TIME_DATE." - [".TIME_SETUP."] ".TYPE_SERVER." -> ".TYPE_MANUAL;
		common_logWrite($logmsg);
	}
}

// time server url write
if( isset($_POST['setAuto']) ) {
	if( $_POST['timeserver'] != $time_servert_name ) {
		common_xmlWriter(TIME_CONF_XML, XML_TIME_SER_IP_PATH, $_POST['timeserver']);
		$logmsg = TIME_DATE." - [".SERVER_ADD_STR."] ".$time_servert_name." -> ".$_POST['timeserver'];
		common_logWrite($logmsg);
		
	} else {
		$logmsg = TIME_DATE." - [".SERVER_ADD_STR."] ".$_POST['timeserver']." ".TIME_UPDATED_STR;
		common_logWrite($logmsg);
	}
	
	$cmd = 'su -c "/usr/sbin/rdate -s ' . $_POST['timeserver'] . '"';
	shell_exec($cmd);
	$changeTime = true;
	
}

//  time manual run
$manual_change = false;
if( isset($_POST['setManual']) ) {
	if( $time_setup == TYPE_SERVER ) {
		$manual_change = true;
		
	} else{
		if ( isChangedTime() ) {
			$manual_change = true;
	
		} else{
		}
	}
}
	
if( $manual_change == true ) {
		$today = mktime($_POST['setHour'], $_POST['setMinute'], $_POST['setSecond'], $_POST['setMonth'], $_POST['setDay'], $_POST['setYear']);
		$todayStr = date('YmdHi.s', $today);
		$cmd = 'su -c "/bin/date -s '.$todayStr.'"';
		shell_exec($cmd);
		
		$mod_time = $_POST['setYear'].".".$_POST['setMonth'].".".$_POST['setDay'].".".$_POST['setHour'].":".$_POST['setMinute'].":".$_POST['setSecond'];
		$logmsg = TIME_DATE." - [".TIME_SETUP."] ". MENUAL_SETUP."-  ".$mod_time;
		common_logWrite($logmsg);
		$changeTime = true;
}
	
if( $changeTime == true ) {
	$cmd = 'su -c "hwclock -wu"';
	shell_exec($cmd);
}
	
if( $changeTimeZone == true ) {
	common_restartConfig(SET_TIME);
}
echo time();
?>
